diff --git a/gcc/testsuite/gcc.target/riscv/xtheadba.c b/gcc/testsuite/gcc.target/riscv/xtheadba.c
index 14cdb1ffe2eb..64ad56011884 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadba.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadba.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadba" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadba
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadbb.c b/gcc/testsuite/gcc.target/riscv/xtheadbb.c
index 66988abf2213..803111b03fb2 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadbb.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadbb.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadbb" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadbb
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadbs.c b/gcc/testsuite/gcc.target/riscv/xtheadbs.c
index 808d7378a7be..ad9fba525971 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadbs.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadbs.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadbs" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadbs
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadcmo.c b/gcc/testsuite/gcc.target/riscv/xtheadcmo.c
index eab8fef421cd..fc13754fe521 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadcmo.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadcmo.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadcmo" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadcmo
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadcondmov.c b/gcc/testsuite/gcc.target/riscv/xtheadcondmov.c
index a239c3f9f46e..ad8a777ab2cc 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadcondmov.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadcondmov.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadcondmov" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadcondmov
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadfmemidx.c b/gcc/testsuite/gcc.target/riscv/xtheadfmemidx.c
index e450c5e5c5ac..1617d9475942 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadfmemidx.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadfmemidx.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadfmemidx" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadfmemidx
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadfmv.c b/gcc/testsuite/gcc.target/riscv/xtheadfmv.c
index e97e8f461f6e..f0558d95cb94 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadfmv.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadfmv.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadfmv" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadfmv
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadint.c b/gcc/testsuite/gcc.target/riscv/xtheadint.c
index ee6989a380ec..c9f45d577423 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadint.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadint.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadint" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadint
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadmac.c b/gcc/testsuite/gcc.target/riscv/xtheadmac.c
index 7c635407b310..aeb3cb034417 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadmac.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadmac.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadmac" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadmac
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadmemidx.c b/gcc/testsuite/gcc.target/riscv/xtheadmemidx.c
index 076eab00f54c..a4716acc0409 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadmemidx.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadmemidx.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadmemidx" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadmemidx
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadmempair.c b/gcc/testsuite/gcc.target/riscv/xtheadmempair.c
index 5135d2175dc6..de88d63ed5b3 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadmempair.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadmempair.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadmempair" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadmempair
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/xtheadsync.c b/gcc/testsuite/gcc.target/riscv/xtheadsync.c
index 835d60c96e9d..ddda51545f15 100644
--- a/gcc/testsuite/gcc.target/riscv/xtheadsync.c
+++ b/gcc/testsuite/gcc.target/riscv/xtheadsync.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv64gc_xtheadsync" { target { rv64 } } } */
 
 #ifndef __riscv_xtheadsync
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zawrs.c b/gcc/testsuite/gcc.target/riscv/zawrs.c
index 0b7e26623439..d61a17b7a487 100644
--- a/gcc/testsuite/gcc.target/riscv/zawrs.c
+++ b/gcc/testsuite/gcc.target/riscv/zawrs.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zawrs" { target { rv32 } } } */
 
 #ifndef __riscv_zawrs
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvbb.c b/gcc/testsuite/gcc.target/riscv/zvbb.c
index b592f56f6cfb..0b78fe4dc622 100644
--- a/gcc/testsuite/gcc.target/riscv/zvbb.c
+++ b/gcc/testsuite/gcc.target/riscv/zvbb.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvbb" { target { rv32 } } } */
 
 #ifndef __riscv_zvbb
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvbc.c b/gcc/testsuite/gcc.target/riscv/zvbc.c
index 37239fa91b33..2a00c965f322 100644
--- a/gcc/testsuite/gcc.target/riscv/zvbc.c
+++ b/gcc/testsuite/gcc.target/riscv/zvbc.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvbc" { target { rv32 } } } */
 
 #ifndef __riscv_zvbc
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvkg.c b/gcc/testsuite/gcc.target/riscv/zvkg.c
index 1e2a05aa1d87..fe0a841e745d 100644
--- a/gcc/testsuite/gcc.target/riscv/zvkg.c
+++ b/gcc/testsuite/gcc.target/riscv/zvkg.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvkg" { target { rv32 } } } */
 
 #ifndef __riscv_zvkg
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvkned.c b/gcc/testsuite/gcc.target/riscv/zvkned.c
index fcdc4b45761e..8f9f2532f3d7 100644
--- a/gcc/testsuite/gcc.target/riscv/zvkned.c
+++ b/gcc/testsuite/gcc.target/riscv/zvkned.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvkned" { target { rv32 } } } */
 
 #ifndef __riscv_zvkned
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvknha.c b/gcc/testsuite/gcc.target/riscv/zvknha.c
index 1275f9d11c18..70242a8cb049 100644
--- a/gcc/testsuite/gcc.target/riscv/zvknha.c
+++ b/gcc/testsuite/gcc.target/riscv/zvknha.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvknha" { target { rv32 } } } */
 
 #ifndef __riscv_zvknha
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvknhb.c b/gcc/testsuite/gcc.target/riscv/zvknhb.c
index 669ff0191496..af89d7b1b7d1 100644
--- a/gcc/testsuite/gcc.target/riscv/zvknhb.c
+++ b/gcc/testsuite/gcc.target/riscv/zvknhb.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvknhb" { target { rv32 } } } */
 
 #ifndef __riscv_zvknhb
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvksed.c b/gcc/testsuite/gcc.target/riscv/zvksed.c
index 439b546bb8a4..2ac58f848199 100644
--- a/gcc/testsuite/gcc.target/riscv/zvksed.c
+++ b/gcc/testsuite/gcc.target/riscv/zvksed.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvksed" { target { rv32 } } } */
 
 #ifndef __riscv_zvksed
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvksh.c b/gcc/testsuite/gcc.target/riscv/zvksh.c
index 5359ca50281b..f7190a42cc29 100644
--- a/gcc/testsuite/gcc.target/riscv/zvksh.c
+++ b/gcc/testsuite/gcc.target/riscv/zvksh.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvksh" { target { rv32 } } } */
 
 #ifndef __riscv_zvksh
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int
diff --git a/gcc/testsuite/gcc.target/riscv/zvkt.c b/gcc/testsuite/gcc.target/riscv/zvkt.c
index 49822b75738d..8871a4aca4c0 100644
--- a/gcc/testsuite/gcc.target/riscv/zvkt.c
+++ b/gcc/testsuite/gcc.target/riscv/zvkt.c
@@ -3,7 +3,7 @@
 /* { dg-options "-march=rv32gc_zvkt" { target { rv32 } } } */
 
 #ifndef __riscv_zvkt
-#error Feature macro not defined
+#error "Feature macro not defined"
 #endif
 
 int