diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-0.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-0.c
index 88a2ac4b338..0959afd57d6 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-0.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-0.c
@@ -23,4 +23,4 @@
 **   fsrm\s+[atx][0-9]+
 **   ...
 */
-TEST_CEIL(_Float16, __builtin_ceilf16)
+TEST_UNARY_CALL (_Float16, __builtin_ceilf16)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-1.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-1.c
index 0908ef269bd..142705b7eed 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-1.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-1.c
@@ -23,4 +23,4 @@
 **   fsrm\s+[atx][0-9]+
 **   ...
 */
-TEST_CEIL(float, __builtin_ceilf)
+TEST_UNARY_CALL (float, __builtin_ceilf)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-2.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-2.c
index 65d4807edef..d232e36e1db 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-2.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-2.c
@@ -23,4 +23,4 @@
 **   fsrm\s+[atx][0-9]+
 **   ...
 */
-TEST_CEIL(double, __builtin_ceil)
+TEST_UNARY_CALL (double, __builtin_ceil)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-3.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-3.c
index 416698a753e..82e4f89a82a 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-3.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-3.c
@@ -25,4 +25,4 @@
 **   fsrm\s+[atx][0-9]+
 **   ...
 */
-TEST_COND_CEIL(float, __builtin_ceilf)
+TEST_COND_UNARY_CALL (float, __builtin_ceilf)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-0.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-0.c
index f1946e197cc..699eaf364e1 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-0.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-0.c
@@ -9,7 +9,7 @@ _Float16 in[ARRAY_SIZE];
 _Float16 out[ARRAY_SIZE];
 _Float16 ref[ARRAY_SIZE];
 
-TEST_CEIL (_Float16, __builtin_ceilf16)
+TEST_UNARY_CALL (_Float16, __builtin_ceilf16)
 TEST_ASSERT (_Float16)
 
 TEST_INIT (_Float16, 1.2, 2.0, 1)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-1.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-1.c
index 202944ddd92..98a412979b5 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-1.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-1.c
@@ -9,7 +9,7 @@ float in[ARRAY_SIZE];
 float out[ARRAY_SIZE];
 float ref[ARRAY_SIZE];
 
-TEST_CEIL (float, __builtin_ceilf)
+TEST_UNARY_CALL (float, __builtin_ceilf)
 TEST_ASSERT (float)
 
 TEST_INIT (float, 1.2, 2.0, 1)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-2.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-2.c
index f0ff9bca0af..22a4d8ab2b9 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-2.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/math-ceil-run-2.c
@@ -9,7 +9,7 @@ double in[ARRAY_SIZE];
 double out[ARRAY_SIZE];
 double ref[ARRAY_SIZE];
 
-TEST_CEIL (double, __builtin_ceil)
+TEST_UNARY_CALL (double, __builtin_ceil)
 TEST_ASSERT (double)
 
 TEST_INIT (double, 1.2, 2.0, 1)
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/test-math.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/test-math.h
index 6e913da37f4..d035835f370 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/test-math.h
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/test-math.h
@@ -1,11 +1,11 @@
-#define TEST_CEIL(TYPE, CALL) \
+#define TEST_UNARY_CALL(TYPE, CALL)                               \
   void test_##TYPE##_##CALL (TYPE *out, TYPE *in, unsigned count) \
   {                                                               \
     for (unsigned i = 0; i < count; i++)                          \
       out[i] = CALL (in[i]);                                      \
   }
 
-#define TEST_COND_CEIL(TYPE, CALL)                                           \
+#define TEST_COND_UNARY_CALL(TYPE, CALL)                                     \
   void test_##TYPE##_##CALL (TYPE *out, int *cond, TYPE *in, unsigned count) \
   {                                                                          \
     for (unsigned i = 0; i < count; i++)                                     \